[(EN)](README.md) **(RU)**

# Конвертер из растровых картинок в мозаику из 3D-примитивов

Программа на Python для превращения растровой картинки в графическом формате ([PNG](http://www.libpng.org/pub/png/)) в набор 3D-объектов в формате [POVRay](https://www.povray.org/). Координаты x, y пикселя соответствуют координатам x, y 3D- объектов, базовый цвет объекта соответствует цвету исходного пикселя.

![Example of p6zaika export rendering](p6.png)

*Краткое описание*
- **s3zaika** - конвертирует каждый пиксель в 3D-сферу, сферы упакованы в плоскую решётку с *треугольной* сеткой (симметрия C<sub>3</sub>). Высота центра сферы над исходной плоскостью зависит от случайного генератора, что позволяет избежать повторяющейся паттерны теней в рендеринге, эффект модулируется переменной в конечном файле вывода.
- **s4zaika** - конвертирует каждый пиксель в 3D-сферу, сферы упакованы в плоскую решётку с *квадратной* сеткой (симметрия C<sub>4</sub>). Высота центра сферы над исходной плоскостью зависит от случайного генератора, эффект модулируется переменной в конечном файле вывода.
- **c3zaika** - конвертирует каждый пиксель в 3D-цилиндр, цилиндры упакованы в плоскую решётку с *треугольной* сеткой (симметрия C<sub>3</sub>). Высота верхней грани цилиндра над исходной плоскостью (размер по вертикали) зависит от яркости исходной картинки, что добавляет объём (наподобие очень грубой карты высот). В целом программа представляет собой гибрид s3zaika (треугольная упаковка) и b4zaikaS (масштабирование согласно яркости исходного изображения).
- **b4zaikaS** - конвертирует каждый пиксель в 3D-параллелепипед ("кубик"), "кубики" упакованы в плоскую решётку с *квадратной* сеткой (симметрия C<sub>4</sub>, правильное разбиение плоскости 4<sub>4</sub>). Высота верхней грани "кубика" над исходной плоскостью (размер по вертикали) зависит от яркости исходного изображения, что добавляет объём (наподобие очень грубой карты высот).
- **b4zaikaR** - конвертирует каждый пиксель в 3D-параллелепипед ("кубик"), "кубики" упакованы в плоскую решётку с *квадратной* сеткой (симметрия C<sub>4</sub>) и повёрнуты на углы вокруг всех осей. По умолчанию поворот вокруг x,y случайный, вокруг z зависит от яркости исходной картинки, что обеспечивает некоторый художественный эффект.
- **p3zaika** -конвертирует каждый пиксель в трёхгранную 3D-призму, призмы упакованы в плоскую решётку с *треугольной* сеткой (симметрия C<sub>3</sub>, правильное разбиение плоскости 3<sub>6</sub>), высота "карандаша" в "сотах" зависит от яркости исходного изображения, что добавляет объём (наподобие очень грубой карты высот).
- **p6zaika** -конвертирует каждый пиксель в шестигранную 3D-призму ("карандаш"), "карандаши" упакованы в плоскую решётку с *шестиугольной* сеткой (симметрия C<sub>6</sub>, "**пчелиные соты**", правильное разбиение плоскости 6<sub>3</sub>), высота "карандаша" в "сотах" зависит от яркости исходного изображения, что добавляет объём (наподобие очень грубой карты высот из упакованных карандашей).

*Описание поддиректорий - более сложные 3D-объекты*

- **superellipsoid/superzaika.py** - конвертирует каждый пиксель в 3D-суперэллипсоид. Параметры суперэллипсоида случайны, что обеспечивает 3D-фигуры в диапазоне от сферы до куба через цилиндры и пирамиды. В целом эффект скорее попсовый, нежели высокохудожественный, но всегда можно попробовать побаловаться с параметрами.

![Example of s3zaika export rendering](s3.png)

*Зависимости от внешних библиотек:* Tkinter, PyPNG

*Инструкция по эксплуатации:* программы оборудованы минималистическим GUI, в результате всё, что вы должны сделать после запуска программы, это с помощью окна "Open..." выбрать и открыть файл PNG, с помощью окна "Save..." выбрать POV-файл для сохранения, подождать, пока программа отработает и закроется, затем открыть полученный POV-файл в POVRay и нажать кнопочку "Render". Экспортированная сцена содержит необходимый минимум глобальных переменных и объектов (камера, свет) для ознакомительного рендеринга без редактирования. Текстуры объекта и параметры камеры и т.п. записаны в максимально общем виде с комментариями, и должны быть просты для понимания и редактирования.

Во избежание санкций проект зеркалится:

[github Dnyarri](https://github.com/Dnyarri/POVmosaic)

[gitflic Dnyarri](https://gitflic.ru/project/dnyarri/povmosaic)
